<?php

function getItemHTML(&$lines,$id='') {
	global $use_autoformat, $path_to_data, $BLXS, $usecache;
	
	if ($id=='' or !$usecache){
		if ($use_autoformat) return BXTagsParser($lines);
		else return implode('',$lines);
	}
	else{
		$filename = $path_to_data.'/'.$id.'.txt';
		$parsedfilename = $path_to_data.'/xx-'.$id.'.txt';
		if(!file_exists($parsedfilename)) {
			$parseditem = BXTagsParser($lines);
			$fp = fopen($parsedfilename,'w') or errDie($BLXS['Err_FileOpen'] . ' ('.$parsedfilename.')');
			fwrite($fp,$parseditem) or errDie($BLXS['Err_FileWrite'] . ' ('.$parsedfilename.')');
			fclose($fp) or errDie($BLXS['Err_FileClose'] . ' ('.$parsedfilename.')');
			return $parseditem;
		}
		elseif (file_exists($filename)) {
		if (filemtime($filename)> filemtime($parsedfilename)){
			$parseditem = BXTagsParser($lines);
			$fp = fopen($parsedfilename,'w') or errDie($BLXS['Err_FileOpen'] . ' ('.$parsedfilename.')');
			fwrite($fp,$parseditem) or errDie($BLXS['Err_FileWrite'] . ' ('.$parsedfilename.')');
			fclose($fp) or errDie($BLXS['Err_FileClose'] . ' ('.$parsedfilename.')');
			return $parseditem;
		}
		else {
			$fp = fopen($parsedfilename,'r') or errDie($BLXS['Err_FileOpen'] . ' ('.$parsedfilename.')');
			$parseditem = fread($fp,filesize($parsedfilename)) or errDie($BLXS['Err_FileRead'] . ' ('.$parsedfilename.')');
			fclose($fp) or errDie($BLXS['Err_FileClose'] . ' ('.$parsedfilename.')');
			return $parseditem;
		}
		}
		else {
		if ($use_autoformat) return BXTagsParser($lines);
		else return implode('',$lines);
		}
	}
	}

function getItemsource(&$lines) {
	return implode('',$lines);
	}

function html2text($html) {
	$t = chop(preg_replace('/<[^>]*>/s','',$html));
	$t = ereg_replace("[\r\n]+",' ',$t);
	$t = ereg_replace('&nbsp;',' ',$t);
	$t = ereg_replace('&mdash;','-',$t);
	$t = ereg_replace('&ndash;','-',$t);
	return $t;
	}

function getAutotitle($HTML,$default) {
	if (eregi('([0-9]+)',trim($default),$r) ) {
		$default = getItemPreview($HTML,$r[1]);
		}
	for ($i=1;$i<=6;$i++) {
		if (preg_match_all('|<h'.$i.'[^>]*>(.*)</h'.$i.'[^>]*>|i',$HTML,$r) ) {
		  $autotile = getItemPreview($r[1][0]);
    $autotile = str_replace('(((','',$autotile);
    $autotile = str_replace(')))','',$autotile);
			return $autotile;
			}
		}
	return $default;
	}

function getItemPreview($txt,$max=256,$desc='') {
	global $BLXS;
	if ($desc) return $desc;
	if (!$max || !($max>=0)) $max=0;
	$t = chop(preg_replace('/<h([1-6][^>]*)>[^<]*<\/h\\1>/s','',$txt));
	$t = html2text($t);
	if (!$t) return '[-'.$BLXS['empty'].'-]';
	if ($max<1 || strlen($t)<=$max) return $t;
	$t = substr($t,0,$max) . '...';
	return $t;
	}

function getItemDescription(&$lines) {
	global $description_prefix;
	$t = '';
	if ($description_prefix) {
		$d = quotemeta($description_prefix);
		$d = addcslashes($d,"|");
		$lCnt = count($lines);
		for ($i=0;$i<$lCnt;$i++)
			if (ereg($d.' (.*)$',$lines[$i],$r)) $t .= parseLine($r[1]).' ';
		}
	return trim(html2text($t));
	}

function getHTMLItemDescription(&$lines) {
	global $description_prefix;
	$t = '';
	if ($description_prefix) {
		$d = quotemeta($description_prefix);
		$d = addcslashes($d,"|");
		$lCnt = count($lines);
		for ($i=0;$i<$lCnt;$i++)
			if (ereg($d.' (.*)$',$lines[$i],$r)) $t .= parseLine($r[1]).' ';
		}
	return trim($t);
	}


function formatDate($txt,$stamp) {
	global $BLXS;
	$mths = array(1=>'Jan',2=>'Feb',3=>'Mar',4=>'Apr',5=>'May',6=>'Jun',7=>'Jul',8=>'Aug',9=>'Sep',10=>'Oct',11=>'Nov',12=>'Dec');

	$t = preg_replace(
		array(
			'/MON/',
			'/Mon/',
			'/mon/',
			'/MTH/',
			'/Mth/',
			'/mth/',
			'/DAY/',
			'/Day/',
			'/day/',
			'/MIN/i',
			'/SEC/i',
			'/DD/i',
			'/D/i',
			'/MM/i',
			'/M/i',
			'/YYYY/i',
			'/YY/i',
			'/hh/i',
			'/h/i'),
		array(
			'~~~@1~~~',
			'~~~@2~~~',
			'~~~@3~~~',
			'~~~@@1~~~',
			'~~~@@2~~~',
			'~~~@@3~~~',
			'~~~#1~~~',
			'~~~#2~~~',
			'~~~#3~~~',
			date('i',$stamp),
			date('s',$stamp),
			date('d',$stamp),
			date('j',$stamp),
			date('m',$stamp),
			date('n',$stamp),
			date('Y',$stamp),
			date('y',$stamp),
			date('H',$stamp),
			date('G',$stamp)
			),
			$txt);

	$mon = strtolower($BLXS['months'][date('n',$stamp)]);
	$t = ereg_replace('~~~@1~~~',strtoupper($mon),$t);
	$t = ereg_replace('~~~@2~~~',ucfirst($mon),$t);
	$t = ereg_replace('~~~@3~~~',$mon,$t);
	
	$mth = strtolower($mths[date('n',$stamp)]);
	$t = ereg_replace('~~~@@1~~~',strtoupper($mth),$t);
	$t = ereg_replace('~~~@@2~~~',ucfirst($mth),$t);
	$t = ereg_replace('~~~@@3~~~',$mth,$t);
	
	$day = strtolower($BLXS['days'][date('w',$stamp)]);
	$t = ereg_replace('~~~#1~~~',strtoupper($day),$t);
	$t = ereg_replace('~~~#2~~~',ucfirst($day),$t);
	$t = ereg_replace('~~~#3~~~',$day,$t);

	return $t;
	}


?>
